/***********************************************************************/
/*                                                                     */
/*   SVMTorch                                                          */
/*                                                                     */
/*   Author: Ronan Collobert                                           */
/*   Date: 21.07.2000                                                  */
/*                                                                     */
/*   Copyright (c) 2000  IDIAP - All rights reserved                   */
/*                                                                     */
/*   This software is available for non-commercial use only. It must   */
/*   not be modified and distributed without prior permission of the   */
/*   author. The author is not responsible for implications from the   */
/*   use of this software.                                             */
/*                                                                     */
/***********************************************************************/
  

#ifndef INC_SVM_FUNCS
#define INC_SVM_FUNCS

#include "general.h"

typedef struct
{
                real *points;
                real *alpha;
                real b;

                int n;
                int w;

} SVM;

typedef struct
{
                real *ex;
                real *Y;
		          real *results;

                int n;
                int w;

} TEST;

SVM *initSVM(void);
TEST *initTEST(void);
void destroySVM(SVM *svm);
void destroyTEST(TEST *test);
void createModelFileAsciiSVM(SVM *svm, char *fc);
void createModelFileBinSVM(SVM *svm, char *fc);
void checkModelSVM(SVM *svm);
void checkTEST(TEST *test);
void loadAsciiTEST(TEST *test, char *fc);
real evaluateSVM(SVM *svm, real *x);
void setKernel(void);
void m_error(void);
void loadBinWTEST(TEST *test, char *fc);
void loadAsciiWTEST(TEST *test, char *fc);
void checkWTEST(TEST *test);
void loadBinTEST(TEST *test, char *fc);

#endif
